/**
 *	Copyrigth(c) 2004 Pertner Co., Ltd. TeamFile Team
 *  $Id$
 *
 *	ファイル名	:	TFBroadCaster.h
 *	クラス名	:	CTFBroadCaster
 *	継承		:
 *
 *	機能　		:	ブロードキャスト通知を送るクラス
 *
 *
 */

#ifndef	TF_LIB_TFBROADCASTER_H
#define	TF_LIB_TFBROADCASTER_H	1

#include "TFWsBrowserHandler.h"
#include "TFLibDefinition.h"
#include "TFCriticalSectionLocker.h"

typedef std::vector<CTFWsBrowserHandler*>	LPBROWSERHANDLER;

TF_BEGIN_CLASSEXPORT

class TF_EXPORT CTFBroadCaster
{
public:

public:
	CTFBroadCaster(void);
	~CTFBroadCaster(void);

	/**
	 *	ハンドラを登録する
	 *	このハンドラへは必ずnewして渡しておく。更に削除は
	 *	登録した側が責任を持つこと。
	 */
	static bool AddHandler(CTFWsBrowserHandler* pHandler);

	/**
	 *	ハンドラを取り外す
	 */
	static bool DeleteHandler(CTFWsBrowserHandler* pHandler);

	/**
	 *	ハンドラが登録されていればTRUE
	 */
	static bool	HasHander(void);

private:

	static LPBROWSERHANDLER		m_vBrowserHandler;
	static CTFCriticalSection	m_cBroadCritSect;
	static unsigned int			m_unCount;
};

TF_END_CLASSEXPORT

#endif
