/**
 *	Copyrigth(c) 2004 Pertner Co., Ltd. TeamFile Team
 *  $Id$
 *
 *	ファイル名	:	TFResourcePropTFGruop.h
 *	クラス名	:	TFResourcePropTFGruop
 *	継承		:
 *
 *	機能　		:	グループリソース
 *
 *
 */
#ifndef TF_LIB_TFRESOURCEPROPTFGROUP_H
#define TF_LIB_TFRESOURCEPROPTFGROUP_H	1

#include "TFResourceProp.h"

TF_BEGIN_CLASSEXPORT

class TF_EXPORT CTFResourcePropTFGroup :
	public CTFResourceProp
{
public:
	CTFResourcePropTFGroup(void);
	virtual ~CTFResourcePropTFGroup(void);
	virtual void Import(const CTFObject& source);

	void SetID(const TFXMLCh* pszID);
	void SetComment(const TFXMLCh* pszComment);
	void SetMailWatch(const TFXMLCh* pszMailWatch);
	void SetGroupCollectionUri(const TFXMLCh* pszUri);
	void SetGroupConstraints(int nConstraints);
	void SetGroupState(int nState);

	const TFXMLCh* GetID(void);
	const TFXMLCh* GetComment(void);
	int GetGrpMailWatch(void);
	const TFXMLCh* GetGroupCollectionUri(void);
	int GetGroupConstraints(void);
	const TFXMLCh* GetGroupConstraintsString(void);
	int GetGroupState(void);

	void SetGroupOwnerName(const TFXMLCh* pszName);
	void SetGroupOwnerID(const TFXMLCh* pszID);
	const TFXMLCh* GetGroupOwnerName(void);
	const TFXMLCh* GetGroupOwnerID(void);

	void SetChildCount(const TFXMLCh* pszChildCount);
	TF_SIZE_T GetChildCount(void);

private:
	TF_STRING_W		m_strID;				///< グループID
//	TF_STRING_W		m_strName;		CTFResourceItemに任せる
	TF_STRING_W		m_strComment;
	int				m_unMailWatch;
	TF_STRING_W		m_strGroupColUri;		//< グループの実際の構成URI
	int				m_nConstraints;
	int				m_nGroupState;			//<　グループステータス
	TF_STRING_W		m_strOwnerName;			//< オーナー名
	TF_STRING_W		m_strOwnerID;			//< オーナーID
	TF_STRING_W		m_strChildCount;		//< 子グループの数

	TF_SIZE_T		m_i64tmp;
	TF_STRING_W		m_strtmp;

protected:
	TFLIB_DECLARE_CLASS(CTFResourcePropTFGroup)

};

TF_END_CLASSEXPORT

#endif

