/**
 *	Copyrigth(c) 2004 Pertner Co., Ltd. TeamFile Team
 *	$Id$
 *
 *	ファイル名	:	TFResourceTFRootTree.h
 *	クラス名		:	CTFResourceTFRootTree
 *	継承			:	CTFResourceProp
 *
 *	機能　		:	ルートツリーサーチを管理しているリソース
 *
 *
 */
#ifndef	TF_LIB_TFDAVRESOURCETFROOTTREE_H
#define	TF_LIB_TFDAVRESOURCETFROOTTREE_H 1

#include "TFResourceProp.h"
#include "TFLibDefinition.h"

TF_BEGIN_CLASSEXPORT

class TF_EXPORT CTFResourceTFRootTree :
	public CTFResourceProp
{
public:
	CTFResourceTFRootTree(void);
	virtual ~CTFResourceTFRootTree(void);
	virtual void Import(const CTFObject& source);

	bool SetDisplayOrder(int iNo);
	bool SetFolderType(const TFXMLCh* pszFolderType);
	void SetSQLNo(const TFXMLCh* pszSQLNo);

	int	 GetDisplayOrder(void);
	TFITEMTYPE GetFolderType(void);
	const TFXMLCh* GetSQLNo(void);

protected:
	int				m_iDisplayOrder;	///< display order
	TF_STRING_W		m_strSQLNo;			///< SQLNO

protected:
	TFLIB_DECLARE_CLASS(CTFResourceTFRootTree)
};

TF_END_CLASSEXPORT

#endif

