/**
 *	Copyrigth(c) 2004 Pertner Co., Ltd. TeamFile Team
 *  $Id$
 *
 *	ファイル名	:	TFXmlBodyPaser.h
 *	クラス名	:	CTFXmlBodyPaser
 *	継承		:	CTFXmlBodyPaserBase
 *
 *	機能　		:	XMLのボディをパースするクラス
 *					
 *
 */

#ifndef TF_LIB_XMLBODYPASER_H
#define TF_LIB_XMLBODYPASER_H 1

#include "TFXMLUtils.h"
#include "TFXmlBodyPaserBase.h"

#include "TFDavResource.h"
#include "TFResourceTFRootTree.h"
#include <onion/DavResourceNode.h>
#include "TFResourcePropTFUser.h"

TF_BEGIN_CLASSEXPORT
class TF_EXPORT CTFXmlBodyPaser :
	public CTFXmlBodyPaserBase
{
public:
	CTFXmlBodyPaser(const TFXMLCh* pszServerID);
	~CTFXmlBodyPaser(void);
	CTFDavResource* Parse(CDavResourceNode* pNode);
	CTFDavResource* Parse(XNS(DOMNode)* pNode);
protected:
	virtual CTFDavResource* OnTFNoDiscoveryFound(XNS(DOMElement)* pResponse);
	virtual CTFDavResource* OnTFStatusDiscoveryFound(XNS(DOMElement)* pStatusDiscovery);
	virtual CTFDavResource* OnTFUserDiscoveryFound(XNS(DOMElement)* pUserDiscovery);
	virtual CTFDavResource* OnTFSysmsgDiscoveryFound(XNS(DOMElement)* pSysmsgDiscovery);
	virtual CTFDavResource* OnTFGroupDiscoveryFound(XNS(DOMElement)* pGroupDiscovery);
	virtual CTFDavResource* OnTFUpdateDiscoveryFound(XNS(DOMElement)* pUpdateDiscovery);

private:
	void parseCommonUserProperty(XNS(DOMElement)* pElement, CTFResourcePropTFUser& pUserItem);
	
	//CTFResourceTFRootTree* ParseRootTree(XNS(DOMNode)* pNode);
};
TF_END_CLASSEXPORT
#endif	// TF_LIB_XMLBODYPASER_H

