#include "TFXmlBodyPropfind.h"
#include "oimap.h"

CTFXmlBodyPropfind::CTFXmlBodyPropfind(void)
{
}

CTFXmlBodyPropfind::~CTFXmlBodyPropfind(void)
{
}

bool 
CTFXmlBodyPropfind::CreateBody(TFLIVEPROP	enuLive,
							   TFLIVEPROPTF enuLiveEx,
							   TFDEADPROP	enuDead)
{
	CTFXmlBodyBuilder	cXMLBuilder;
	
	try {	
		cXMLBuilder.Initialize(C2W("propfind"));
		cXMLBuilder.AddDefaultNameSpace();
		cXMLBuilder.AddPropChild(C2W("prop"), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));

		if (enuLive & LP_CREATIONDATE)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_CREATIONDATE), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
		if (enuLive & LP_DISPLAYNAME)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_DISPLAYNAME), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
		if (enuLive & LP_GETCONTENTLANGUAGE)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_GETCONTENTLANGUAGE), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
		if (enuLive & LP_GETCONTENTLENGTH)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_GETCONTENTLENGTH), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
		if (enuLive & LP_GETCONTENTTYPE)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_GETCONTENTTYPE), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
		if (enuLive & LP_GETETAG)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_GETETAG), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
		if (enuLive & LP_GETLASTMODIFIED)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_GETLASTMODIFIED), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
		if (enuLive & LP_RESOURCETYPE)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_RESOURCETYPE), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
		if (enuLive & LP_RESOURCE)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_RESOURCE), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
		if (enuLive & LP_SUPPORTEDLOCK)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_SUPPORTEDLOCK), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
		if (enuLive & LP_LOCKDISCOVERY)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_LOCKDISCOVERY), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
//		if (enuLive & LP_SUPPOREDQUERYGRAMMERSET)
//			cXMLBuilder.AddPropSibling(C2W(TF_PROP_LOCKDISCOVERY), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
//		if (enuLive & LP_SUPPOTEDMETHOD)
//			cXMLBuilder.AddPropSibling(C2W(TF_PROP_LOCKDISCOVERY), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
//		if (enuLive & LP_QUOTABYTES)
//			cXMLBuilder.AddPropSibling(C2W(TF_PROP_LOCKDISCOVERY), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
//		if (enuLive & LP_QUOTAUSEDBYTE)
//			cXMLBuilder.AddPropSibling(C2W(TF_PROP_LOCKDISCOVERY), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));
//		if (enuLive & LP_STORAGEQUOTAREACHED)	
//			cXMLBuilder.AddPropSibling(C2W(TF_PROP_LOCKDISCOVERY), C2W(TF_DAV_XML_NSURI), C2W(DAV_XML_NAMESPACE_PREFIX));

		if (enuLiveEx & LP_EX_CREATOR)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_CREATOR), C2W(TF_XML_NSURI), C2W(TF_XML_NAMESPACE_PREFIX));
		if (enuLiveEx & LP_EX_LASTMODIFIER)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_LASTMODIFIER), C2W(TF_XML_NSURI), C2W(TF_XML_NAMESPACE_PREFIX));
		if (enuLiveEx & LP_EX_SHAREDCOLLECTION)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_SHAREDCOLLECTION), C2W(TF_XML_NSURI), C2W(TF_XML_NAMESPACE_PREFIX));
		if (enuLiveEx & LP_EX_MAILWATCH)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_MAILWATCH), C2W(TF_XML_NSURI), C2W(TF_XML_NAMESPACE_PREFIX));
		if (enuLiveEx & LP_EX_TRASHINFORMATION)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_TRASHINFORMATION), C2W(TF_XML_NSURI), C2W(TF_XML_NAMESPACE_PREFIX));
		if (enuLiveEx & LP_EX_RESOURCESTATE)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_RESOURCESTATE), C2W(TF_XML_NSURI), C2W(TF_XML_NAMESPACE_PREFIX));
		if (enuLiveEx & LP_EX_USERPRIVILEGEGRANTSET)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_USERPRIVILEGEGRANTSET), C2W(TF_XML_NSURI), C2W(TF_XML_NAMESPACE_PREFIX));
		if (enuLiveEx & LP_EX_SYSTEMQUOTA)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_SYSTEMQUOTA), C2W(TF_XML_NSURI), C2W(TF_XML_NAMESPACE_PREFIX));
			
		if (enuDead & DP_COMMENT)
			cXMLBuilder.AddPropSibling(C2W(TF_PROP_COMMENT), C2W(TF_XML_NSURI), C2W(TF_XML_NAMESPACE_PREFIX));

	} catch (...) {
		return false;
	}
	
	return ImportDocument(cXMLBuilder, m_xbfBody.GetDocument());
}

